'
' Demonstrate a HID (Human Interface Device) interface
'
' When connected to the PC, the mouse pointer will rotate in a small square

	Device = 18F4550								' Choose a device with on-board USB 2.0
    XTAL = 48										' Set the oscillator speed to 48MHz (using a 20MHz crystal)
    
    REMINDERS = OFF									' Disable all reminders
     
    USB_DESCRIPTOR = "MOUSDESC.ASM"					' Point to the MOUSE DESCRIPTOR file
       
    Dim BUFFER[4]   as Byte
	Dim LOOP_COUNT	as	Byte
	Dim POSITION	as	Byte
    
    Symbol CARRY_FLAG = STATUS.0					' Carry flag of the STATUS register
'------------------------------------------------------------------------
' The main program loop starts here 
   
    Delayms 200											' Wait for things to stabilise
    Clear												' Clear all RAM before we start   

	While 1 = 1
		For POSITION = 0 To 3							' Move through each position
			For LOOP_COUNT = 0 To 31					' 32 steps in each direction
				Select POSITION
                	Case 0								' Move UP ?
                    	BUFFER#1 = 0
						BUFFER#2 = -2
                    Case 1								' Move RIGHT ?
                    	BUFFER#1 = 2
						BUFFER#2 = 0
                    Case 2								' Move DOWN ?
                    	BUFFER#1 = 0
						BUFFER#2 = 2
                    Case 3								' Move LEFT ?
                    	BUFFER#1 = -2
						BUFFER#2 = 0
                End Select
				Repeat
					USBOut 1, BUFFER, 4  				' Send the buffer to endpoint 1
				Until CARRY_FLAG = 0					' Keep trying if the buffer has not been transmitted
            Next
		Next
	Wend
    
    
